import { baseRequest } from '@/utils/request'

const request = (url, ...arg) => baseRequest(`/purchaseAndSalesSupervision/` + url, ...arg)
const requestADD = (url, ...arg) => baseRequest(`/yjbjController/` + url, ...arg)
const requestBBC = (url, ...arg) => baseRequest(`/orgInfo/` + url, ...arg)
const requestEER = (url, ...arg) => baseRequest(`/biz/enum/` + url, ...arg)

//
// 获取模型优化-粮情模型优化表分页
export default {
	LQMXYHlist(data) {
		return request('bizPssMoGrain/page', data, 'get')
	},
	LQMXYHcode(data) {
		return request('bizPssMoGrain/isEnabledById', data, 'get')
	},
	LQMXYHdel(data) {
		return request('bizPssMoGrain/delete', data, 'post')
	},
	LQMXYHadd(data) {
		return request('bizPssMoGrain/add', data, 'post')
	},
	LQMXYHview(data) {
		return request('bizPssMoGrain/detail', data, 'get')
	},
	LQMXYHedit(data) {
		return request('bizPssMoGrain/edit', data, 'post')
	},
	// 获取模型优化-在库时间异常模型优化表分页
	YCMXYHlist(data) {
		return request('bizPssMoInventoryTimeAnomaly/page', data, 'get')
	},
	YCMXYHadd(data) {
		return request('bizPssMoInventoryTimeAnomaly/add', data, 'post')
	},
	YCMXYHview(data) {
		return request('bizPssMoInventoryTimeAnomaly/detail', data, 'get')
	},
	YCMXYHdel(data) {
		return request('bizPssMoInventoryTimeAnomaly/delete', data, 'post')
	},
	YCMXYHcode(data) {
		return request('bizPssMoInventoryTimeAnomaly/isEnabledById', data, 'get')
	},
	YCMXYHedit(data) {
		return request('bizPssMoInventoryTimeAnomaly/edit', data, 'post')
	},
	// 获取-轮空期模型优化表分页
	MXYHBlist(data) {
		return request('bizPssMoRotationEmptyPeriod/page', data, 'get')
	},
	MXYHBdel(data) {
		return request('bizPssMoRotationEmptyPeriod/delete', data, 'post')
	},
	MXYHBcode(data) {
		return request('bizPssMoRotationEmptyPeriod/isEnabledById', data, 'get')
	},
	MXYHBadd(data) {
		return request('bizPssMoRotationEmptyPeriod/add', data, 'post')
	},
	MXYHBdetail(data) {
		return request('bizPssMoRotationEmptyPeriod/detail', data, 'get')
	},
	MXYHBedit(data) {
		return request('bizPssMoRotationEmptyPeriod/edit', data, 'post')
	},
	// 获取财务类业务监管-资金信息对接采集表分页
	ZJDJCJlist(data) {
		return request('bizPssFundDockCollect/page', data, 'get')
	},
	ZJDJCJdel(data) {
		return request('bizPssFundDockCollect/delete', data, 'post')
	},
	ZJDJCJadd(data) {
		return request('bizPssFundDockCollect/add', data, 'post')
	},
	ZJDJCJview(data) {
		return request('bizPssFundDockCollect/detail', data, 'get')
	},
	ZJDJCJedit(data) {
		return request('bizPssFundDockCollect/edit', data, 'post')
	},
	// 获取财务类业务监管-偿还风险预警表分页
	CHFXYJBlist(data) {
		return request('bizPssRepaymentRiskWarn/page', data, 'get')
	},
	CHFXYJBdel(data) {
		return request('bizPssRepaymentRiskWarn/delete', data, 'post')
	},
	CHFXYJBname(data) {
		return request('bizPssRepaymentRiskWarn/getOrgInfoIdAndName', data, 'get')
	},
	CHFXYJBadd(data) {
		return request('bizPssRepaymentRiskWarn/add', data, 'post')
	},
	CHFXYJBview(data) {
		return request('bizPssRepaymentRiskWarn/detail', data, 'get')
	},
	CHFXYJBedit(data) {
		return request('bizPssRepaymentRiskWarn/edit', data, 'post')
	},
	// 获取购销监管-财务类业务监管-轮空期监管表分页
	CWLXYWJGlist(data) {
		return request('pssstorageemptyperiod/page', data, 'get')
	},
	// *出库计划执行监管
	CRKJHZXJGlist(data) {
		return requestADD('getCkjhzxjgList', data, 'get')
	},
	BSONGYWlist(data) {
		return requestBBC('info/getAllList', data, 'get')
	},

	//字典
	HQZDlist(data) {
		return requestEER('getAllChildren', data, 'get')
	}
}
