import * as echarts from 'echarts'
export function useaddDAta (nameDEl, mapFeatures, toolTipData, delsWZ) {
	let data = [
		{ name: '西宁市', value: 123 }
		// // { name: '海东市', value: 123 }
	]
	const result = toolTipData.reduce((acc, curr) => {
		const index = acc.findIndex((item) => item.name === curr.name)
		if (index === -1) {
			acc.push({
				name: curr.name,
				value: [curr.value]
			})
		} else {
			acc[index].value.push(curr.value)
		}
		return acc
	}, [])
	// const resultData = toolTipData.reduce((acc, curr) => {
	// 	const index = acc.findIndex((item) => item.name === curr.name)
	// 	if (index === -1) {
	// 		acc.push({
	// 			name: curr.name,
	// 			value: 133
	// 		})
	// 	}
	// 	return acc
	// }, [])

	// data = resultData
	// console.log(data)
	let geoCoordMap = {}
	// let toolTipData = [
	// 	{
	// 		name: '西宁市',
	// 		value: 1233
	// 	},
	// 	{ name: '海东市', value: 12223 }
	// ]
	mapFeatures.features.forEach(function (v) {
		var name = v.properties.name
		geoCoordMap[name] = v.properties.centroid
	})

	var convertData = function (data) {
		var res = []
		// for (var i = 0; i < data.length; i++) {
		// 	var geoCoord = geoCoordMap[data[i].name]
		// 	// console.log(geoCoordMap)
		// 	if (geoCoord) {
		// 		res.push({
		// 			name: data[i].name,
		// 			value: geoCoord.concat(data[i].value)
		// 		})
		// 	}
		// }
		// res.push(
		// 	{
		// 		// name: '海东市',
		// 		value: [102.467176, 36.988548, 111]
		// 	},
		// 	{
		// 		// name: '海东市',
		// 		value: [101.47176, 34.988548, 111]
		// 	}
		// )

		res = delsWZ
		return res
	}
	echarts.registerMap(nameDEl, mapFeatures)
	return {
		backgroundColor: 'rgba(17, 42, 62, 1)', //"#012366",
		tooltip: {
			show: true,
			padding: 0,
			enterable: true,
			transitionDuration: 1,
			textStyle: {
				color: '#000',
				decoration: 'none'
			},
			position: function (point, params, dom, rect, size) {
				return [point[0], point[1]]
			},
			formatter: function (params) {
				var tipHtml = ''
				let del = ''
				if (toolTipData) {
					result.forEach((v) => {
						if (v.name == params.name) {
							v.value.forEach((item) => {
								return (del += `
								<br/>	   ${item || '暂无库区'} 
								`)
							})
						}
					})
				}
				tipHtml =
					'<div style="width:280px;min-height: 100px;;background:rgba(22,80,158,0.8);border:1px solid rgba(7,166,255,0.7)">' +
					'<div style="width:100%;height:40px;line-height:40px;border-bottom:2px solid rgba(7,166,255,0.7);padding:0 20px">' +
					'<i style="display:inline-block;width:8px;height:8px;background:#16d6ff;border-radius:40px;">' +
					'</i>' +
					'<span style="margin-left:10px;color:#fff;font-size:16px;">' +
					params.name +
					'</span>' +
					'</div>' +
					'<div style="padding:10px">' +
					'<p style="color:#fff;font-size:12px;">' +
					'<i style="display:inline-block;width:8px;height:8px;background:#16d6ff;border-radius:30px;margin:0 8px">' +
					'</i>' +
					'库区名称:' +
					'<span style="color:#11ee7d;margin:0 6px; ">' +
					del

				return tipHtml
			}
		},

		visualMap: {
			show: false,
			min: 0,
			max: 200,
			left: '10%',
			top: 'bottom',
			calculable: true,
			seriesIndex: [1],
			inRange: {
				color: ['#68548E', '#84EE7E']
			}
		},
		geo: {
			top: '5%',
			right: '0%',
			bottom: '5%',
			left: '0%',
			show: true,
			map: nameDEl,
			roam: false,
			selectedMode: 'single', // 设置为 false 可以禁止选中
			label: {
				show: true,
				color: '#fff',
				fontSize: 12
			},
			itemStyle: {
				select: {
					color: 'red' // 设置选中状态下的背景颜色为红色
				},
				normal: {
					color: '#2F6EB6', //bac
					borderColor: '#fff' //bac
				},
				emphasis: {
					color: '#3E7FDA', // 选中区域的背景颜色
					borderColor: '#fff', //bac

					label: {
						show: false,
						color: '#DB5D51',
						fontSize: 12
					}
				}
			}
		},
		series: [
			{
				name: '散点',
				type: 'scatter',
				coordinateSystem: 'geo',
				data: convertData(data),
				symbolSize: function (val) {
					return val[2] / 30
				},
				label: {
					normal: {
						formatter: '{b}',
						position: 'right',
						show: true
					},
					emphasis: {
						show: true
					}
				},
				itemStyle: {
					normal: {
						color: '#DB5D51'
					}
				}
			},
			{
				type: 'map',
				map: nameDEl,
				geoIndex: 0,
				aspectScale: 0.95, //长宽比
				showLegendSymbol: false, // 存在legend时显示
				label: {
					normal: {
						show: true
					},
					emphasis: {
						show: false,
						textStyle: {
							color: 'red'
						}
					}
				},
				roam: true,
				itemStyle: {
					normal: {
						color: '#2F6EB6', //bac
						borderColor: '#fff' //bac
					},
					emphasis: {
						areaColor: 'red'
					}
				},
				animation: false,
				data: data
			},
			{
				name: '点',
				type: 'scatter',
				coordinateSystem: 'geo',
				zlevel: 6,
				tooltip: {
					show: false
				}
			},
			{
				name: 'Top 5',
				type: 'effectScatter',
				coordinateSystem: 'geo',
				tooltip: {
					show: false
				},
				data: convertData(
					data
						.sort(function (a, b) {
							return b.value - a.value
						})
						.slice(0, 10)
				),
				symbolSize: function (val) {
					return val[2] / 30
				},
				showEffectOn: 'render',
				rippleEffect: {
					brushType: 'stroke'
				},
				hoverAnimation: true,
				label: {
					normal: {
						formatter: '{b}',
						position: 'left',
						show: false
					}
				},
				itemStyle: {
					normal: {
						color: 'red',
						shadowBlur: 10,
						shadowColor: 'yellow'
					}
				},
				zlevel: 1
			}
		]
	}
}

export function useaddB (datav, arr) {
	// var colorList = ['#FFFF54', '#AE7731', '#ABF04B', '#75FBFD']
	var seriesData = datav.map((item, index) => {
		return {
			...item,
			actValue: item.value,
			label: {
				show: true,
				position: 'inner',
				// position: 'outside',
				borderRadius: 5,
				padding: [5, 5, 5, 5],
				color: '#464646',
				textStyle: {
					fontSize: 14,
					lineHeight: 20
				},
				formatter: '{b}\n{c}\n{d}%'
			}
		}
	})
	return {
		// color: '#fff',
		backgroundColor: 'rgba(17, 42, 62, 1)', //"#012366",
		grid: {
			top: 0,
			bottom: 0,
			left: 0,
			right: 0
		},
		title: {
			text: '',
			x: 'center'
		},
		tooltip: {
			trigger: 'item',
			formatter: '{a} <br/>{b} : {c} ({d}%)',
			textStyle: {
				fontSize: 12
			}
		},
		legend: {
			show: true,
			// orient: 'vertical',
			left: 'center',
			textStyle: {
				color: '#fff'
			},
			bottom: 0,
			data: arr
		},
		series: [
			{
				color: ['#FFFF54', '#AE7731', '#ABF04B', '#75FBFD'],
				name: '分地区库存统计',
				type: 'pie',
				radius: '65%',
				center: ['50%', '50%'],
				label: {
					show: true,
					// formatter: '{b} {d}%',
					formatter: '{d}%'
				},
				// itemStyle: {
				//   //饼图之间颜色
				//   normal: {
				//     borderColor: "#fff",
				//     borderWidth: 4,
				//   },
				// },
				labelLine: {
					length: 10, //视觉引导线第一段的长度
					length2: 10 //视觉引导线第二段的长度
				},
				data: seriesData
			}
		]
	}
}

export function useaddC (datav, arr) {
	let myData4 = ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月']
	let hc = [1100, 1200, 800, 900, 1000, 400, 500, 1200]
	let qc = [1500, 1600, 1200, 1300, 1400, 800, 700, 1600]
	let llc = [1200, 1400, 800, 1000, 1100, 1000, 1200, 1000]
	return {
		backgroundColor: '#091224',
		tooltip: {
			trigger: 'axis',
			axisPointer: {
				type: 'shadow',
				textStyle: {
					color: '#fff'
				}
			},
			textStyle: {
				color: '#fff'
			},
			backgroundColor: 'rgba(0, 58, 99, 0.8)', //设置背景颜色
			borderColor: 'rgba(0, 58, 99, 0.8)',
			confine: true
		},
		legend: {
			icon: 'rect',
			itemWidth: 14,
			itemHeight: 10,
			itemGap: 20,
			right: '2%',
			top: '2%',
			textStyle: {
				fontSize: 14,
				color: '#fff'
			},
			data: ['入库数量', '结余库存数量', '出库数量'],
			selectedMode: true
		},
		grid: {
			top: '14%',
			left: '2%',
			right: '2%',
			bottom: '6%',
			containLabel: true
		},
		dataZoom: [
			{
				show: true,
				height: 8,
				bottom: '2%',
				right: '3%',
				showDetail: false,
				brushSelect: false,
				backgroundColor: '#1F7ECE', // 背景颜色
				showDataShadow: false,
				borderColor: 'transparent',
				fillerColor: '#00C0FF', //拉动框的颜色
				startValue: 0,
				endValue: 5,
				handleSize: '60%',
				zoomLock: true,
				// 画一个圆形
				handleIcon:
					'path://M30.9,53.2C16.8,53.2,5.3,41.7,5.3,27.6S16.8,2,30.9,2C45,2,56.4,13.5,56.4,27.6S45,53.2,30.9,53.2z M30.9,3.5M36.9,35.8h-1.3z M27.8,35.8 h-1.3H27L27.8,35.8L27.8,35.8z',
				handleStyle: {
					// 两侧缩放手柄的样式配置。
					borderColor: '#fff',
					borderWidth: '5',
					shadowBlur: 1,
					background: '#fff',
					shadowColor: '#fff'
				}
			}
		],
		xAxis: {
			type: 'category',
			data: myData4,
			axisPointer: {
				type: 'shadow'
			},
			axisLabel: {
				color: '#A4A7AA',
				interval: 0,
				fontSize: 12
			},
			axisLine: {
				show: true,
				lineStyle: {
					color: 'rgba(127, 214, 255, .4)'
				}
			},
			splitLine: {
				show: false
			},
			axisTick: {
				show: false
			}
		},
		yAxis: {
			type: 'value',
			name: '亿吨',
			nameTextStyle: {
				color: '#A4A7AA',
				fontSize: 12
			},
			axisLine: {
				show: false,
				lineStyle: {
					color: 'rgba(127, 214, 255, .4)'
				}
			},
			min: 0,
			axisLabel: {
				show: true,
				color: '#A4A7AA',
				fontSize: 12
			},
			axisTick: {
				show: true
			},
			splitLine: {
				show: true,
				lineStyle: {
					width: 0.8,
					color: 'rgba(127, 214, 255, .4)',
					type: 'dashed'
				}
			}
		},
		series: [
			{
				data: hc,
				name: '入库数量',
				type: 'bar',
				barWidth: '10px',
				barGap: '60%',
				itemStyle: {
					normal: {
						borderColor: 'rgba(54, 129, 255, 1)',
						color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
							{
								offset: 0,
								color: 'rgba(15, 51, 82, 1)'
							},

							{
								offset: 1,
								color: 'rgba(0, 168, 255, 1)'
							}
						])
					}
				},
				label: {
					show: false,
					position: 'top',
					fontSize: 12,
					color: '#F5F5F5',
					offset: [0, -5],
					formatter: '{c}'
				}
			},
			{
				data: qc,
				name: '结余库存数量',
				type: 'bar',
				barWidth: '10px',
				barGap: '60%',
				itemStyle: {
					normal: {
						borderColor: 'rgba(255, 207, 91, 1)',
						color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
							{
								offset: 0,
								color: 'rgba(63, 51, 22, 1)'
							},

							{
								offset: 1,
								color: 'rgba(215, 158, 20, 1)'
							}
						])
					}
				},
				label: {
					show: false,
					position: 'top',
					fontSize: 12,
					color: '#F5F5F5',
					offset: [0, -5],
					formatter: '{c}'
				}
			},
			{
				data: llc,
				name: '出库数量',
				type: 'bar',
				barWidth: '10px',
				barGap: '60%',
				itemStyle: {
					normal: {
						borderColor: 'rgba(54, 234, 255, 1)',
						color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
							{
								offset: 0,
								color: 'rgba(15, 51, 82, 1)'
							},

							{
								offset: 1,
								color: 'rgba(21, 219, 203, 1)'
							}
						])
					}
				},
				label: {
					show: false,
					position: 'top',
					fontSize: 12,
					color: '#F5F5F5',
					offset: [0, -5],
					formatter: '{c}'
				}
			}
		]
	}
}

export function useaddD (datav, arr) {
	// 绘制左侧面
	const CubeLeft = echarts.graphic.extendShape({
		shape: {
			x: 0,
			y: 0
		},
		buildPath: function (ctx, shape) {
			const xAxisPoint = shape.xAxisPoint
			const c0 = [shape.x, shape.y]
			const c1 = [shape.x - 13, shape.y - 13]
			const c2 = [xAxisPoint[0] - 13, xAxisPoint[1] - 13]
			const c3 = [xAxisPoint[0], xAxisPoint[1]]
			ctx.moveTo(c0[0], c0[1]).lineTo(c1[0], c1[1]).lineTo(c2[0], c2[1]).lineTo(c3[0], c3[1]).closePath()
		}
	})
	// 绘制右侧面
	const CubeRight = echarts.graphic.extendShape({
		shape: {
			x: 0,
			y: 0
		},
		buildPath: function (ctx, shape) {
			const xAxisPoint = shape.xAxisPoint
			const c1 = [shape.x, shape.y]
			const c2 = [xAxisPoint[0], xAxisPoint[1]]
			const c3 = [xAxisPoint[0] + 18, xAxisPoint[1] - 9]
			const c4 = [shape.x + 18, shape.y - 9]
			ctx.moveTo(c1[0], c1[1]).lineTo(c2[0], c2[1]).lineTo(c3[0], c3[1]).lineTo(c4[0], c4[1]).closePath()
		}
	})
	// 绘制顶面
	const CubeTop = echarts.graphic.extendShape({
		shape: {
			x: 0,
			y: 0
		},
		buildPath: function (ctx, shape) {
			const c1 = [shape.x, shape.y]
			const c2 = [shape.x + 18, shape.y - 9]
			const c3 = [shape.x + 5, shape.y - 22]
			const c4 = [shape.x - 13, shape.y - 13]
			ctx.moveTo(c1[0], c1[1]).lineTo(c2[0], c2[1]).lineTo(c3[0], c3[1]).lineTo(c4[0], c4[1]).closePath()
		}
	})
	// 注册三个面图形
	echarts.graphic.registerShape('CubeLeft', CubeLeft)
	echarts.graphic.registerShape('CubeRight', CubeRight)
	echarts.graphic.registerShape('CubeTop', CubeTop)
	// 数据
	const VALUE = [34, 34.8, 20.2, 54.9, 40.5, 60.3, 19.0, 20.9, 60.8, 20.2, 54.9, 74.5, 60.3]

	const VALUEDel = [64, 44.8, 10.2, 34.9, 20.5, 30.3, 10.0, 10.9, 60.8, 20.2, 54.9, 54.5, 40.3]
	return {
		backgroundColor: 'rgba(17, 42, 62, 1)', //"#012366",
		tooltip: {
			trigger: 'axis',
			axisPointer: {
				type: 'none',
				shadowStyle: {
					color: 'rgba(216, 230, 255, .2)'
				},
				label: {
					show: false,
					color: '#517FFD',
					backgroundColor: 'transparent',
					fontSize: 12
				}
			},
			className: 'my-tooltip-box',
			formatter: function (params) {
				var str = `<div class="my-tooltip">${params[0].name}<br/>`
				console.log()
				params.forEach((el) => {
					if (el.seriesName !== 'maxdata') {
						str += `<div><span class="name large">${el.seriesName}：</span><span class="value">
            ${el.seriesName === params[1].seriesName ? el.value + '%' : el.value} 
            ${el.componentSubType === 'bar' ? gdpUnit || '' : ''}
            </span></div>`
					}
				})
				str += '</div>'
				return str
			}
		},
		grid: {
			left: 20,
			right: 20,
			bottom: 20,
			top: 60,
			containLabel: true
		},
		legend: {
			data: ['粮食入库', '增长率'],
			bottom: '0%',
			clickable: false,
			selectedMode: true,
			itemWidth: 12,
			itemHeight: 12,
			textStyle: {
				color: 'rgba(107, 107, 107, 1)',
				fontSize: 16
			}
		},
		xAxis: {
			type: 'category',
			data: [
				'2021/9',
				'2021/10',
				'2021/11',
				'2021/12',
				'2022/1',
				'2022/2',
				'2022/3',
				'2022/4',
				'2022/5',
				'2022/6',
				'2022/7',
				'2022/8',
				'2022/9'
			],
			axisLine: {
				show: false,
				lineStyle: {
					color: 'white'
				}
			},
			// offset: 25,
			axisTick: {
				show: false,
				length: 9,
				alignWithLabel: true,
				lineStyle: {
					color: '#7DFFFD'
				}
			},
			axisLabel: {
				show: true,
				fontSize: 12,
				rotate: 45
			}
		},
		yAxis: [
			{
				min: 0,
				max: 100,
				// interval: 200,
				type: 'value',
				name: '万吨',
				axisLine: {
					show: false,
					lineStyle: {
						color: 'white'
					}
				},
				splitLine: {
					show: true,
					lineStyle: {
						type: 'dashed',
						color: 'rgba(255,255,255,0.1)'
					}
				},
				axisTick: {
					show: false
				},
				axisLabel: {
					show: true,
					fontSize: 12
				},
				boundaryGap: ['20%', '20%']
			},
			{
				name: '',
				type: 'value',
				min: 0,
				max: 100,
				axisLabel: {
					show: true,
					fontSize: 12,
					formatter: '{value}%'
					// outside: true
				},
				axisLine: {
					show: false,
					lineStyle: {
						color: 'white'
					}
				},
				splitLine: {
					show: true,
					lineStyle: {
						type: 'solid',
						color: '#fff'
					}
				},
				axisTick: {
					show: true
				},
				boundaryGap: ['20%', '20%']
			}
		],
		series: [
			{
				name: '粮食入库',
				type: 'custom',
				renderItem: (params, api) => {
					const location = api.coord([api.value(0), api.value(1)])
					var color =
						api.value(1) > 10000
							? 'red'
							: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
								{
									offset: 0,
									color: '#5cc4eb'
								},
								{
									offset: 0.8,
									color: '#21658c'
								}
							])
					return {
						type: 'group',
						children: [
							{
								type: 'CubeLeft',
								shape: {
									api,
									xValue: api.value(0),
									yValue: api.value(1),
									x: location[0],
									y: location[1],
									xAxisPoint: api.coord([api.value(0), 0])
								},
								style: {
									fill: (color =
										api.value(1) > 10000
											? 'red'
											: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
												{
													offset: 0,
													color: '#5cc4eb'
												},
												{
													offset: 0.8,
													color: '#21658c'
												}
											]))
								}
							},
							{
								type: 'CubeRight',
								shape: {
									api,
									xValue: api.value(0),
									yValue: api.value(1),
									x: location[0],
									y: location[1],
									xAxisPoint: api.coord([api.value(0), 0])
								},
								style: {
									fill: (color =
										api.value(1) > 10000
											? 'red'
											: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
												{
													offset: 0,
													color: '#048fd4'
												},
												{
													offset: 0.8,
													color: '#195684'
												}
											]))
								}
							},
							{
								type: 'CubeTop',
								shape: {
									api,
									xValue: api.value(0),
									yValue: api.value(1),
									x: location[0],
									y: location[1],
									xAxisPoint: api.coord([api.value(0), 0])
								},
								style: {
									fill: (color =
										api.value(1) > 10000
											? 'red'
											: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
												{
													offset: 0,
													color: '#65c7ec'
												},
												{
													offset: 1,
													color: '#65c7ec'
												}
											]))
								}
							}
						]
					}
				},

				data: VALUE
			},
			{
				name: '增长率',
				type: 'line',
				smooth: true,
				itemStyle: {
					normal: {
						color: '#FFCC64' // 折线的颜色
					}
				},
				data: VALUEDel
			}
		]
	}
}

// export function useaddF(datav, arr) {
// 	var noise = getNoiseHelper()
// 	var xData = []
// 	var yData = []
// 	noise.seed(Math.random())
// 	function generateData(theta, min, max) {
// 		var data = []
// 		for (var i = 0; i <= 200; i++) {
// 			for (var j = 0; j <= 100; j++) {
// 				// var x = (max - min) * i / 200 + min;
// 				// var y = (max - min) * j / 100 + min;
// 				data.push([i, j, noise.perlin2(i / 40, j / 20) + 0.5])
// 				// data.push([i, j, normalDist(theta, x) * normalDist(theta, y)]);
// 			}
// 			xData.push(i)
// 		}
// 		for (var j = 0; j < 100; j++) {
// 			yData.push(j)
// 		}
// 		return data
// 	}
// 	var data = generateData(2, -5, 5)

// 	console.log(data)

// 	///////////////////////////////////////////////////////////////////////////
// 	// Simplex and perlin noise helper from https://github.com/josephg/noisejs
// 	///////////////////////////////////////////////////////////////////////////
// 	function getNoiseHelper(global) {
// 		var module = {}

// 		function Grad(x, y, z) {
// 			this.x = x
// 			this.y = y
// 			this.z = z
// 		}

// 		Grad.prototype.dot2 = function (x, y) {
// 			return this.x * x + this.y * y
// 		}

// 		Grad.prototype.dot3 = function (x, y, z) {
// 			return this.x * x + this.y * y + this.z * z
// 		}

// 		var grad3 = [
// 			new Grad(1, 1, 0),
// 			new Grad(-1, 1, 0),
// 			new Grad(1, -1, 0),
// 			new Grad(-1, -1, 0),
// 			new Grad(1, 0, 1),
// 			new Grad(-1, 0, 1),
// 			new Grad(1, 0, -1),
// 			new Grad(-1, 0, -1),
// 			new Grad(0, 1, 1),
// 			new Grad(0, -1, 1),
// 			new Grad(0, 1, -1),
// 			new Grad(0, -1, -1)
// 		]

// 		var p = [
// 			151, 160, 137, 91, 90, 15, 131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240,
// 			21, 10, 23, 190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33, 88,
// 			237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166, 77, 146, 158, 231, 83,
// 			111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244, 102, 143, 54, 65, 25, 63, 161, 1, 216,
// 			80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196, 135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186,
// 			3, 64, 52, 217, 226, 250, 124, 123, 5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58,
// 			17, 182, 189, 28, 42, 223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9,
// 			129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228, 251, 34, 242, 193,
// 			238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107, 49, 192, 214, 31, 181, 199, 106, 157,
// 			184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254, 138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128,
// 			195, 78, 66, 215, 61, 156, 180
// 		]
// 		// To remove the need for index wrapping, double the permutation table length
// 		var perm = new Array(512)
// 		var gradP = new Array(512)

// 		// This isn't a very good seeding function, but it works ok. It supports 2^16
// 		// different seed values. Write something better if you need more seeds.
// 		module.seed = function (seed) {
// 			if (seed > 0 && seed < 1) {
// 				// Scale the seed out
// 				seed *= 65536
// 			}

// 			seed = Math.floor(seed)
// 			if (seed < 256) {
// 				seed |= seed << 8
// 			}

// 			for (var i = 0; i < 256; i++) {
// 				var v
// 				if (i & 1) {
// 					v = p[i] ^ (seed & 255)
// 				} else {
// 					v = p[i] ^ ((seed >> 8) & 255)
// 				}

// 				perm[i] = perm[i + 256] = v
// 				gradP[i] = gradP[i + 256] = grad3[v % 12]
// 			}
// 		}

// 		module.seed(0)

// 		/*
//   for(var i=0; i<256; i++) {
//     perm[i] = perm[i + 256] = p[i];
//     gradP[i] = gradP[i + 256] = grad3[perm[i] % 12];
//   }*/

// 		// Skewing and unskewing factors for 2, 3, and 4 dimensions
// 		var F2 = 0.5 * (Math.sqrt(3) - 1)
// 		var G2 = (3 - Math.sqrt(3)) / 6

// 		var F3 = 1 / 3
// 		var G3 = 1 / 6

// 		// 2D simplex noise
// 		module.simplex2 = function (xin, yin) {
// 			var n0, n1, n2 // Noise contributions from the three corners
// 			// Skew the input space to determine which simplex cell we're in
// 			var s = (xin + yin) * F2 // Hairy factor for 2D
// 			var i = Math.floor(xin + s)
// 			var j = Math.floor(yin + s)
// 			var t = (i + j) * G2
// 			var x0 = xin - i + t // The x,y distances from the cell origin, unskewed.
// 			var y0 = yin - j + t
// 			// For the 2D case, the simplex shape is an equilateral triangle.
// 			// Determine which simplex we are in.
// 			var i1, j1 // Offsets for second (middle) corner of simplex in (i,j) coords
// 			if (x0 > y0) {
// 				// lower triangle, XY order: (0,0)->(1,0)->(1,1)
// 				i1 = 1
// 				j1 = 0
// 			} else {
// 				// upper triangle, YX order: (0,0)->(0,1)->(1,1)
// 				i1 = 0
// 				j1 = 1
// 			}
// 			// A step of (1,0) in (i,j) means a step of (1-c,-c) in (x,y), and
// 			// a step of (0,1) in (i,j) means a step of (-c,1-c) in (x,y), where
// 			// c = (3-sqrt(3))/6
// 			var x1 = x0 - i1 + G2 // Offsets for middle corner in (x,y) unskewed coords
// 			var y1 = y0 - j1 + G2
// 			var x2 = x0 - 1 + 2 * G2 // Offsets for last corner in (x,y) unskewed coords
// 			var y2 = y0 - 1 + 2 * G2
// 			// Work out the hashed gradient indices of the three simplex corners
// 			i &= 255
// 			j &= 255
// 			var gi0 = gradP[i + perm[j]]
// 			var gi1 = gradP[i + i1 + perm[j + j1]]
// 			var gi2 = gradP[i + 1 + perm[j + 1]]
// 			// Calculate the contribution from the three corners
// 			var t0 = 0.5 - x0 * x0 - y0 * y0
// 			if (t0 < 0) {
// 				n0 = 0
// 			} else {
// 				t0 *= t0
// 				n0 = t0 * t0 * gi0.dot2(x0, y0) // (x,y) of grad3 used for 2D gradient
// 			}
// 			var t1 = 0.5 - x1 * x1 - y1 * y1
// 			if (t1 < 0) {
// 				n1 = 0
// 			} else {
// 				t1 *= t1
// 				n1 = t1 * t1 * gi1.dot2(x1, y1)
// 			}
// 			var t2 = 0.5 - x2 * x2 - y2 * y2
// 			if (t2 < 0) {
// 				n2 = 0
// 			} else {
// 				t2 *= t2
// 				n2 = t2 * t2 * gi2.dot2(x2, y2)
// 			}
// 			// Add contributions from each corner to get the final noise value.
// 			// The result is scaled to return values in the interval [-1,1].
// 			return 70 * (n0 + n1 + n2)
// 		}

// 		// 3D simplex noise
// 		module.simplex3 = function (xin, yin, zin) {
// 			var n0, n1, n2, n3 // Noise contributions from the four corners

// 			// Skew the input space to determine which simplex cell we're in
// 			var s = (xin + yin + zin) * F3 // Hairy factor for 2D
// 			var i = Math.floor(xin + s)
// 			var j = Math.floor(yin + s)
// 			var k = Math.floor(zin + s)

// 			var t = (i + j + k) * G3
// 			var x0 = xin - i + t // The x,y distances from the cell origin, unskewed.
// 			var y0 = yin - j + t
// 			var z0 = zin - k + t

// 			// For the 3D case, the simplex shape is a slightly irregular tetrahedron.
// 			// Determine which simplex we are in.
// 			var i1, j1, k1 // Offsets for second corner of simplex in (i,j,k) coords
// 			var i2, j2, k2 // Offsets for third corner of simplex in (i,j,k) coords
// 			if (x0 >= y0) {
// 				if (y0 >= z0) {
// 					i1 = 1
// 					j1 = 0
// 					k1 = 0
// 					i2 = 1
// 					j2 = 1
// 					k2 = 0
// 				} else if (x0 >= z0) {
// 					i1 = 1
// 					j1 = 0
// 					k1 = 0
// 					i2 = 1
// 					j2 = 0
// 					k2 = 1
// 				} else {
// 					i1 = 0
// 					j1 = 0
// 					k1 = 1
// 					i2 = 1
// 					j2 = 0
// 					k2 = 1
// 				}
// 			} else {
// 				if (y0 < z0) {
// 					i1 = 0
// 					j1 = 0
// 					k1 = 1
// 					i2 = 0
// 					j2 = 1
// 					k2 = 1
// 				} else if (x0 < z0) {
// 					i1 = 0
// 					j1 = 1
// 					k1 = 0
// 					i2 = 0
// 					j2 = 1
// 					k2 = 1
// 				} else {
// 					i1 = 0
// 					j1 = 1
// 					k1 = 0
// 					i2 = 1
// 					j2 = 1
// 					k2 = 0
// 				}
// 			}
// 			// A step of (1,0,0) in (i,j,k) means a step of (1-c,-c,-c) in (x,y,z),
// 			// a step of (0,1,0) in (i,j,k) means a step of (-c,1-c,-c) in (x,y,z), and
// 			// a step of (0,0,1) in (i,j,k) means a step of (-c,-c,1-c) in (x,y,z), where
// 			// c = 1/6.
// 			var x1 = x0 - i1 + G3 // Offsets for second corner
// 			var y1 = y0 - j1 + G3
// 			var z1 = z0 - k1 + G3

// 			var x2 = x0 - i2 + 2 * G3 // Offsets for third corner
// 			var y2 = y0 - j2 + 2 * G3
// 			var z2 = z0 - k2 + 2 * G3

// 			var x3 = x0 - 1 + 3 * G3 // Offsets for fourth corner
// 			var y3 = y0 - 1 + 3 * G3
// 			var z3 = z0 - 1 + 3 * G3

// 			// Work out the hashed gradient indices of the four simplex corners
// 			i &= 255
// 			j &= 255
// 			k &= 255
// 			var gi0 = gradP[i + perm[j + perm[k]]]
// 			var gi1 = gradP[i + i1 + perm[j + j1 + perm[k + k1]]]
// 			var gi2 = gradP[i + i2 + perm[j + j2 + perm[k + k2]]]
// 			var gi3 = gradP[i + 1 + perm[j + 1 + perm[k + 1]]]

// 			// Calculate the contribution from the four corners
// 			var t0 = 0.6 - x0 * x0 - y0 * y0 - z0 * z0
// 			if (t0 < 0) {
// 				n0 = 0
// 			} else {
// 				t0 *= t0
// 				n0 = t0 * t0 * gi0.dot3(x0, y0, z0) // (x,y) of grad3 used for 2D gradient
// 			}
// 			var t1 = 0.6 - x1 * x1 - y1 * y1 - z1 * z1
// 			if (t1 < 0) {
// 				n1 = 0
// 			} else {
// 				t1 *= t1
// 				n1 = t1 * t1 * gi1.dot3(x1, y1, z1)
// 			}
// 			var t2 = 0.6 - x2 * x2 - y2 * y2 - z2 * z2
// 			if (t2 < 0) {
// 				n2 = 0
// 			} else {
// 				t2 *= t2
// 				n2 = t2 * t2 * gi2.dot3(x2, y2, z2)
// 			}
// 			var t3 = 0.6 - x3 * x3 - y3 * y3 - z3 * z3
// 			if (t3 < 0) {
// 				n3 = 0
// 			} else {
// 				t3 *= t3
// 				n3 = t3 * t3 * gi3.dot3(x3, y3, z3)
// 			}
// 			// Add contributions from each corner to get the final noise value.
// 			// The result is scaled to return values in the interval [-1,1].
// 			return 32 * (n0 + n1 + n2 + n3)
// 		}

// 		// ##### Perlin noise stuff

// 		function fade(t) {
// 			return t * t * t * (t * (t * 6 - 15) + 10)
// 		}

// 		function lerp(a, b, t) {
// 			return (1 - t) * a + t * b
// 		}

// 		// 2D Perlin Noise
// 		module.perlin2 = function (x, y) {
// 			// Find unit grid cell containing point
// 			var X = Math.floor(x),
// 				Y = Math.floor(y)
// 			// Get relative xy coordinates of point within that cell
// 			x = x - X
// 			y = y - Y
// 			// Wrap the integer cells at 255 (smaller integer period can be introduced here)
// 			X = X & 255
// 			Y = Y & 255

// 			// Calculate noise contributions from each of the four corners
// 			var n00 = gradP[X + perm[Y]].dot2(x, y)
// 			var n01 = gradP[X + perm[Y + 1]].dot2(x, y - 1)
// 			var n10 = gradP[X + 1 + perm[Y]].dot2(x - 1, y)
// 			var n11 = gradP[X + 1 + perm[Y + 1]].dot2(x - 1, y - 1)

// 			// Compute the fade curve value for x
// 			var u = fade(x)

// 			// Interpolate the four results
// 			return lerp(lerp(n00, n10, u), lerp(n01, n11, u), fade(y))
// 		}

// 		// 3D Perlin Noise
// 		module.perlin3 = function (x, y, z) {
// 			// Find unit grid cell containing point
// 			var X = Math.floor(x),
// 				Y = Math.floor(y),
// 				Z = Math.floor(z)
// 			// Get relative xyz coordinates of point within that cell
// 			x = x - X
// 			y = y - Y
// 			z = z - Z
// 			// Wrap the integer cells at 255 (smaller integer period can be introduced here)
// 			X = X & 255
// 			Y = Y & 255
// 			Z = Z & 255

// 			// Calculate noise contributions from each of the eight corners
// 			var n000 = gradP[X + perm[Y + perm[Z]]].dot3(x, y, z)
// 			var n001 = gradP[X + perm[Y + perm[Z + 1]]].dot3(x, y, z - 1)
// 			var n010 = gradP[X + perm[Y + 1 + perm[Z]]].dot3(x, y - 1, z)
// 			var n011 = gradP[X + perm[Y + 1 + perm[Z + 1]]].dot3(x, y - 1, z - 1)
// 			var n100 = gradP[X + 1 + perm[Y + perm[Z]]].dot3(x - 1, y, z)
// 			var n101 = gradP[X + 1 + perm[Y + perm[Z + 1]]].dot3(x - 1, y, z - 1)
// 			var n110 = gradP[X + 1 + perm[Y + 1 + perm[Z]]].dot3(x - 1, y - 1, z)
// 			var n111 = gradP[X + 1 + perm[Y + 1 + perm[Z + 1]]].dot3(x - 1, y - 1, z - 1)

// 			// Compute the fade curve value for x, y, z
// 			var u = fade(x)
// 			var v = fade(y)
// 			var w = fade(z)

// 			// Interpolate
// 			return lerp(
// 				lerp(lerp(n000, n100, u), lerp(n001, n101, u), w),
// 				lerp(lerp(n010, n110, u), lerp(n011, n111, u), w),
// 				v
// 			)
// 		}

// 		return module
// 	}

// 	return {
// 		tooltip: {},
// 		xAxis: {
// 			type: 'category',
// 			data: xData
// 		},
// 		yAxis: {
// 			type: 'category',
// 			data: yData
// 		},
// 		visualMap: {
// 			min: 0,
// 			max: 1,
// 			top: '75%',
// 			left: 20,
// 			calculable: true,
// 			realtime: false,
// 			inRange: {
// 				color: ['#313695', '#4575b4', '#74add1', '#abd9e9', '#fdae61', '#f46d43', '#d73027', '#a50026']
// 			}
// 		},
// 		series: [
// 			{
// 				name: 'Gaussian',
// 				type: 'heatmap',
// 				data: data,
// 				emphasis: {
// 					itemStyle: {
// 						borderColor: '#333',
// 						borderWidth: 1
// 					}
// 				},
// 				progressive: 1000,
// 				animation: false
// 			}
// 		]
// 	}
// }
